﻿using Paperwork.Connect;
using Paperwork.Library;
using Paperwork.Types;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace StartWorkflowProject
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                bool SSLEnable = true;
                string CertFile = @"C:\Paperwork\Certs\ggsoft.cer";
                string Server = "argusdev.g-gsoft.com";
                string Port = "8099";
                string UserLogin = "trainer";
                string PassWord = "gg";
                Productivity productivity = new Productivity(ClientTypes.ProductivityLayer, SSLEnable, CertFile);
                productivity.InitRemObjects(Server, Port);
                a_LoginInfo loginInfo = productivity.rLogin.Login(UserLogin, PassWord, "PL Akış Başlatma Uygulaması");
                if (loginInfo.ErrorCode != "0")
                    throw new Exception(loginInfo.LMessage);

                productivity.InitAssemblies();

                var result = new a_GenericResult();
                var prcs = productivity.rWorkflow.GetProcesses(2);
                var prc = prcs.Items.FirstOrDefault(k => k.ProcessTitle == "GELEN_FATURA_SURECI");
                a_Workflow flwData = new a_Workflow();
                flwData.WorkflowName = string.Format("PL Akış Örneği - {0}", DateTime.Now.ToString());
                flwData.ProcessId = new ObjectID(prc.ProcessId);
                flwData.AclId = new ObjectID(prc.AclId);
                flwData.WorkflowId = new ObjectID(string.Empty);
                flwData.FormName = new ObjectName(prc.FormName);
                flwData.FormVersion = "1";
                flwData.TypeName = new ObjectName(prc.ObjectType);
                flwData.Version = string.Empty;
                flwData.Owner = UserLogin;
                flwData.State = WORKFLOWState.Init;
                flwData.CreateDate = DateTime.Now;
                flwData.Priority = 0;
                flwData.AttachmentId = new ObjectID(string.Empty);
                ITypes fObject = productivity.rDocument.getDocument(new ObjectID(string.Empty), prc.ObjectType);
                PW_SYSOBJECT sObject = fObject as PW_SYSOBJECT;
                sObject.FORM_NAME = flwData.FormName.Value;
                sObject.FORM_VERSION = flwData.FormVersion;
                sObject.OBJECT_NAME = flwData.WorkflowName;
                sObject.ACL_ID = flwData.AclId.Value;
                sObject.OWNER = UserLogin;
                sObject.FOLDER_ID = DefaultObjects.WorkflowDir;
                sObject.OBJECT_TYPE = flwData.TypeName.Value;
                sObject.CONTENT_TYPE = Definitions.CONTENT_TYPE_FLOW;
                sObject.VIRTUAL_DOC_ID = string.Empty;
                sObject.IS_FTS = true;
                sObject.IS_VIRTUAL_DOC = false;
                sObject.IS_LAST_VERSION = true;
                fObject.Set("ETTN", "000d322a-9884-4b2f-93cc-4ba03d68a94d");
                fObject.Set("FATURA_NO", "IPA2050000002634");
                fObject.Set("FATURA_TIPI", "IADE");
                fObject.Set("SATICI_FIRMA_ADI", "GGOSFT");
                fObject.Set("SATICI_FIRMA_VKN", "3390198159");
                flwData.FormData = fObject;
                var createRes = productivity.rWorkflow.CreateWorkflow(flwData, string.Empty);
                if (createRes.ErrorCode != 0)
                    throw new Exception(createRes.Message);

                a_GenericResult lo = productivity.rLogin.Logout(loginInfo.SessionId);
                if (lo.ErrorCode != 0)
                    throw new Exception(lo.Message);
            }
            catch (Exception ex)
            {
                throw ex;
            }

        }
    }
}
